﻿using Dto;
using Entities;
using Model.OrderCriteria;
using Shared;
using Shared.Mapper;

namespace API.Service;

public class LessonDataServiceApi(ILessonService<LessonEntity> lessonService) : ILessonService<LessonDTO>
{
    public IEnumerable<LessonDTO> GetLessons(int page, int number, LessonOrderCriteria orderCriteria)
    {
        var lessonsEntities = lessonService.GetLessons(page, number, orderCriteria);
        return lessonsEntities.Select(e => e.FromEntityToDTO()).ToList();
    }

    public LessonDTO GetLessonById(int id) => lessonService.GetLessonById(id).FromEntityToDTO();

    public LessonDTO GetLessonByTitle(string title) => lessonService.GetLessonByTitle(title).FromEntityToDTO();

    public bool DeleteLesson(int id) => lessonService.DeleteLesson(id);

    public LessonDTO UpdateLesson(int id, LessonDTO lesson) =>
        lessonService.UpdateLesson(id, lesson.FromDTOToEntity()).FromEntityToDTO();

    public LessonDTO UpdateLesson(int id, LessonEntity lesson) =>
        lessonService.UpdateLesson(id, lesson).FromEntityToDTO();

    public LessonDTO CreateLesson(string title, string lastPublisher, DateOnly? lastEdit) =>
        lessonService.CreateLesson(title, lastPublisher, lastEdit).FromEntityToDTO();
}