﻿using Dto;
using Entities;
using Model.OrderCriteria;
using Shared;
using Shared.Mapper;

namespace API.Service;

public class SuccessDataServiceApi(ISuccessService<SuccessEntity> sucessService) : ISuccessService<SuccessDTO>
{
    public IEnumerable<SuccessDTO> GetSuccesses(int page, int number, SuccessOrderCriteria orderCriteria)
    {
        var successesEntities = sucessService.GetSuccesses(page, number, orderCriteria);
        return successesEntities.Select(e => e.FromEntityToDTO()).ToList();
    }

    public SuccessDTO GetSuccessByUserId(int id) => sucessService.GetSuccessByUserId(id).FromEntityToDTO();

    public SuccessDTO GetSuccessByInquiryId(int id) => sucessService.GetSuccessByInquiryId(id).FromEntityToDTO();

    public bool DeleteSuccess(int id) => sucessService.DeleteSuccess(id);

    public SuccessDTO UpdateSuccess(int id, SuccessDTO success) =>
        sucessService.UpdateSuccess(id, success.FromDTOToEntity()).FromEntityToDTO();

    public SuccessDTO CreateSuccess(int userId, int inquiryId, bool isFinished) =>
        sucessService.CreateSuccess(userId, inquiryId, isFinished).FromEntityToDTO();
}