using Entities;

namespace TestEF;

public class TestNotepadEntity
{
    private const int _id = 42;
    private const int _userId = 42;
    private static UserEntity _userEntity = new UserEntity();
    private const int _inquiryId = 42;
    private static InquiryEntity _inquiryEntity = new InquiryEntity();
    private const string _notes = "This is some notes example";

    [Fact]
    public void TestDefaultConstructor()
    {
        NotepadEntity notepad = new NotepadEntity();
        Assert.Equal(0, notepad.Id);
        Assert.Equal(0, notepad.UserId);
        Assert.Null(notepad.User);
        Assert.Equal(0, notepad.InquiryId);
        Assert.Null(notepad.Inquiry);
        Assert.Null(notepad.Notes);
    }

    [Fact]
    public void TestConstructorWithoutId()
    {
        NotepadEntity notepad = new NotepadEntity(_userId, _userEntity, _inquiryId, _inquiryEntity, _notes);
        Assert.Equal(0, notepad.Id);
        Assert.Equal(_userId, notepad.UserId);
        Assert.Equal(_userEntity, notepad.User);
        Assert.Equal(_inquiryId, notepad.InquiryId);
        Assert.Equal(_inquiryEntity, notepad.Inquiry);
        Assert.Equal(_notes, notepad.Notes);
    }

    [Fact]
    public void TestConstructorWithAllAttributes()
    {
        NotepadEntity notepad = new NotepadEntity(_id, _userId, _userEntity, _inquiryId, _inquiryEntity, _notes);
        Assert.Equal(_id, notepad.Id);
        Assert.Equal(_userId, notepad.UserId);
        Assert.Equal(_userEntity, notepad.User);
        Assert.Equal(_inquiryId, notepad.InquiryId);
        Assert.Equal(_inquiryEntity, notepad.Inquiry);
        Assert.Equal(_notes, notepad.Notes);
    }
}