using Entities;

namespace TestEF;

public class TestSuccessEntity
{
    private const int _userId = 42;
    private const int _inquiryId = 7;
    private const bool _isFinished = true;

    [Fact]
    public void TestDefaultConstructor()
    {
        SuccessEntity success = new SuccessEntity();
        Assert.Equal(0, success.UserId);
        Assert.Null(success.User);
        Assert.Equal(0, success.InquiryId);
        Assert.Null(success.Inquiry);
        Assert.False(success.IsFinished);
    }

    [Fact]
    public void TestConstructorWithIds()
    {
        SuccessEntity success = new SuccessEntity(_userId, _inquiryId, _isFinished);
        Assert.Equal(_userId, success.UserId);
        Assert.Null(success.User);
        Assert.Equal(_inquiryId, success.InquiryId);
        Assert.Null(success.Inquiry);
        Assert.True(success.IsFinished);
    }

    [Fact]
    public void TestConstructorWithNavigationProperties()
    {
        UserEntity user = new UserEntity();
        InquiryEntity inquiry = new InquiryEntity();
        SuccessEntity success = new SuccessEntity(user, inquiry, _isFinished);
        Assert.Equal(0, success.UserId);
        Assert.NotNull(success.User);
        Assert.Equal(0, success.InquiryId);
        Assert.NotNull(success.Inquiry);
        Assert.True(success.IsFinished);
    }

    [Fact]
    public void TestConstructorWithAllAttributes()
    {
        UserEntity user = new UserEntity();
        InquiryEntity inquiry = new InquiryEntity();
        SuccessEntity success = new SuccessEntity(_userId, user, _inquiryId, inquiry, _isFinished);
        Assert.Equal(_userId, success.UserId);
        Assert.NotNull(success.User);
        Assert.Equal(_inquiryId, success.InquiryId);
        Assert.NotNull(success.Inquiry);
        Assert.True(success.IsFinished);
    }
}